aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorBrian Foster <bfoster@redhat.com>2016-08-15 08:56:26 -0400
committerEryu Guan <eguan@redhat.com>2016-09-28 11:36:32 +0800
commitd008c3a5f72a3ca75989b00429a17200b0035466 (patch)
tree6c0b2e4563c9c9ff25371a734fd72727057fb4b3
parent09b981f6ac2b871934587974445f29b51e7e1f5e (diff)
downloadxfstests-dev-d008c3a5f72a3ca75989b00429a17200b0035466.tar.gz
generic: shutdown fs after log recovery
XFS had a bug that lead to a possible out-of-order log recovery situation (e.g., replay a stale modification from the log over more recent metadata in destination buffer). This resulted in false corruption reports during log recovery and thus mount failure. This condition is caused by system crash or filesystem shutdown shortly after a successful log recovery. Add a test to run a combined workload, fs shutdown and log recovery loop known to reproduce the problem on affected kernels. Signed-off-by: Brian Foster <bfoster@redhat.com> Reviewed-by: Eryu Guan <eguan@redhat.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rwxr-xr-xtests/generic/38889
-rw-r--r--tests/generic/388.out2
-rw-r--r--tests/generic/group1
3 files changed, 92 insertions, 0 deletions
diff --git a/tests/generic/388 b/tests/generic/388
new file mode 100755
index 0000000000..c00a7548cb
--- /dev/null
+++ b/tests/generic/388
@@ -0,0 +1,89 @@
+#! /bin/bash
+# FS QA Test No. 388
+#
+# Test XFS log recovery ordering on v5 superblock filesystems. XFS had a problem
+# where it would incorrectly replay older modifications from the log over more
+# recent versions of metadata due to failure to update metadata LSNs during log
+# recovery. This could result in false positive reports of corruption during log
+# recovery and permanent mount failure.
+#
+# To test this situation, run frequent shutdowns immediately after log recovery.
+# Ensure that log recovery does not recover stale modifications and cause
+# spurious corruption reports and/or mount failures.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+ $KILLALL_PROG -9 fsstress > /dev/null 2>&1
+ _scratch_unmount > /dev/null 2>&1
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+
+# Modify as appropriate.
+_supported_fs generic
+_supported_os Linux
+
+_require_scratch
+_require_scratch_shutdown
+_require_command "$KILLALL_PROG" "killall"
+
+rm -f $seqres.full
+
+echo "Silence is golden."
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount || _fail "mount failed"
+
+for i in $(seq 1 50); do
+ ($FSSTRESS_PROG -d $SCRATCH_MNT -n 999999 -p 4 >> $seqres.full &) \
+ > /dev/null 2>&1
+
+ # purposely include 0 second sleeps to test shutdown immediately after
+ # recovery
+ sleep $((RANDOM % 3))
+ $XFS_IO_PROG -xc shutdown $SCRATCH_MNT
+
+ ps -e | grep fsstress > /dev/null 2>&1
+ while [ $? -eq 0 ]; do
+ $KILLALL_PROG -9 fsstress > /dev/null 2>&1
+ wait > /dev/null 2>&1
+ ps -e | grep fsstress > /dev/null 2>&1
+ done
+
+ # quit if mount fails so we don't shutdown the host fs
+ _scratch_cycle_mount || _fail "cycle mount failed"
+done
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/388.out b/tests/generic/388.out
new file mode 100644
index 0000000000..1c2df728a5
--- /dev/null
+++ b/tests/generic/388.out
@@ -0,0 +1,2 @@
+QA output created by 388
+Silence is golden.
diff --git a/tests/generic/group b/tests/generic/group
index 151d3671e2..05f16e7f9b 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -390,3 +390,4 @@
385 quota auto quick
386 auto quick quota
387 auto clone
+388 auto log metadata